jQuery(function($) {
	HTMLCollection.prototype.forEach = Array.prototype.forEach;
	// Retourne un helper avec la largeur des div lors du défilement.
	var fixHelper = function(e, ui) {
	  ui.children().each(function() {
	    $(this).width($(this).width());
	  });
	  return ui;
	};
	// retour le slug du postype contenu dans le $_GET['post_type'] de l'url
	var getPostType = function (post_type) {
		var result = null;
		var tmp = [];
		var items = location.search.substr(1).split("&");
		for (var index = 0; index < items.length; index++) {
			tmp = items[index].split("=");
			if (tmp[0] === post_type) result = decodeURIComponent(tmp[1]);
		}
		if(result === null){ result = 'post'; } // ajout le support des Article par defaut de WP
		return result;
	}
	//https://api.jqueryui.com/sortable/
	$('.wp-list-table tbody').sortable({
		axis: 'y',
		handle: '.column-order img',
		placeholder: 'ui-state-highlight', // element rajouté pendant le scroll
		helper: fixHelper, // fix la largeur des cellules quand on scroll
		start: function(event, ui) {
			$('.ui-state-highlight').height($(ui.item).height());
			$(ui.item).css({
				'background': '#e0dddd',
			});
			var t = $('.ui-state-highlight');
			//Je recupere le nombre de colonnes dans le helper ( element que l'on scroll )
			var cols = ui.helper[0].children;
			// et je compte le nombre d'éléments qui ont la class hidden
			var hidden_num = 0;
			var total_num = 0;
			cols.forEach(function(element, i){
				if (element.classList.contains('hidden')) {
					hidden_num++;
				}
				total_num++;
			});

			if(hidden_num != 0){
				// je parcours les enfants du helper et j'applique au X premier la class hidden, ce qui supprime le bug d'affichage
				var children_helper = t[0].children;
				children_helper.forEach(function(element, i){
					if(i >= hidden_num){
						element.classList.add('hidden');
					}
				});
				// // et idem pour la largeur du placeholder quand le background est gris
				var children_placeholder = ui.placeholder[0].children;
				// // je les affiche tous
				children_placeholder.forEach(function(element, i){
					element.classList.remove('hidden');
				});
				// // pour ensuite controller le nombre souhaité
				var col_restantes = total_num - hidden_num;
				children_placeholder.forEach(function(element, i){
					if(i >= col_restantes){
						element.classList.add('hidden');
					}
				});
			}

			if(vars.SHOW_NUMBER_COLUMN) {
				// crée un attribut temporaire sur l'élément avec l'ancien index
				$(this).attr('data-previndex', ui.item.index());
				// Enfin, affichage du mini loader pendant le scroll
				var list_post_id = $(this).sortable('toArray');
				var loader_html = '<img src="'+vars.currentFileFolder+'/ajax_loader_small.gif" alt="loader" />';
				$( list_post_id ).each(function( index ) {
					// je stock le le current menu order dans le cas il ne changerait pas
					$('#'+list_post_id[index]).find('.menu-order').attr('data-prevmenuorder', $('#'+list_post_id[index]).find('.menu-order').html());
					$('#'+list_post_id[index]).find('.menu-order').html(loader_html);
				});
			}
		},
		stop: function(event, ui) {
			$(ui.item).css({
				'background': '',
				'width': ''
			});
			if(vars.SHOW_NUMBER_COLUMN) {
				var newIndex = ui.item.index();
				var oldIndex = $(this).attr('data-previndex');
				// Si l'element n'a pas changé de position, alors le Update n'est pas executé, je ne dois plus afficher le mini loader
				if(newIndex == oldIndex) {
					var list_post_id = $(this).sortable('toArray');
					$( list_post_id ).each(function( index ) {
						var prevmenuorder = $('#'+list_post_id[index]).find('.menu-order').attr('data-prevmenuorder');
						$('#'+list_post_id[index]).find('.menu-order').html(prevmenuorder);
					});
				}
			}
		},
		update: function(event, ui) {
			var theOrder = $(this).sortable('toArray');
			var postType = getPostType('post_type');
			var datas = {
				action: 'update_post_order',
				postType: postType,
				order: theOrder
			};
			// on vient mettre à jour les data des colonnes via ajax
			$.ajax(vars.ajaxurl, {
				 	data: datas,
					type: "POST",
					// beforeSend: function() {},
					error: function(e) {
						console.log(e);
					},
					success: function(data) {
						if(vars.SHOW_NUMBER_COLUMN) {
							$( data.new_order ).each(function( index ) {
								// On vient cibler la colonne qui affiche ne nombre de l'ordre et on remplace le mini loader par le nouveau numero
								var pid = '#post-'+$(data.new_order)[index].post_id;
								var new_num_order = $(data.new_order)[index].menu_order;
								$(pid).find('.menu-order').html(new_num_order);
							});
						}
					}
			});
		}
	}).disableSelection();

});
